/* -*- buffer-read-only: t -*- vi: set ro:
   THIS FILE IS GENERATED AUTOMATICALLY.  PLEASE DO NOT EDIT.
*/
#define MF_SOURCE_NAME  MF_SOURCE_BI_OTHER
#ifdef HAVE_CONFIG_H
# include <config.h>
#endif
#include <sys/types.h>
#include "mailfromd.h"
#include "prog.h"
#include "builtin.h"

#line 1 "bi_other.m4"
/* This file is part of Mailfromd.             -*- c -*-
   Copyright (C) 2006, 2007, 2008 Sergey Poznyakoff

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 3, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>. */

static int
valid_user_p(eval_environ_t env, const char *name)
{
	int rc;
	struct mu_auth_data *auth_data = NULL;

#if HAVE_MU_GET_AUTH
	rc = mu_get_auth(&auth_data, mu_auth_key_name, name);
	mu_auth_data_free(auth_data);
	switch (rc) {
	case 0:
		rc = 1;
		break;
		
	case MU_ERR_AUTH_FAILURE:
		rc = 0;
		break;

	case EAGAIN:
                	env_throw_bi(env, mfe_temp_failure, NULL, _("Temporary failure querying for username %s"),name);
#line 39
		break;

	default:
                	env_throw_bi(env, mfe_failure, NULL, _("Failure querying for username %s"),name);
#line 45
		break;
	}
#else
	auth_data = mu_get_auth_by_name(name);
	rc = auth_data != NULL;
	mu_auth_data_free(auth_data);
#endif
	debug2(10, "Checking user %s: %s", name,
	       rc ? "true" : "false");
	return rc;
}

void
#line 57
bi_validuser(eval_environ_t env)
#line 57

#line 57 "bi_other.m4"
{
#line 57
	
#line 57

#line 57

#line 57
char * name;
#line 57
        
#line 57
get_string_arg(env, 0, &name);
#line 57
        
#line 57

#line 57
        adjust_stack(env, 1);
#line 57

#line 57
	if (prog_trace_option & BUILTIN_MASK_other)
#line 57
		prog_trace(env, "validuser %s",name);;
#line 57

{
	
#line 59
do {
#line 59
  push(env, (STKVAL) (valid_user_p(env, name)));
#line 59
  return;
#line 59
} while (0);
}
}

void
#line 63
bi_interval(eval_environ_t env)
#line 63

#line 63 "bi_other.m4"
{
#line 63
	
#line 63

#line 63

#line 63
char * str;
#line 63
        
#line 63
get_string_arg(env, 0, &str);
#line 63
        
#line 63

#line 63
        adjust_stack(env, 1);
#line 63

#line 63
	if (prog_trace_option & BUILTIN_MASK_other)
#line 63
		prog_trace(env, "interval %s",str);;
#line 63

{
       time_t t;
       const char *endp;

       	if (!(parse_time_interval(str, &t, &endp) == 0))
#line 68
			env_throw_bi(env, mfe_invtime, "interval", _("Unrecognized time format (near `%s')"),endp)
#line 70
;
       
#line 71
do {
#line 71
  push(env, (STKVAL) (t));
#line 71
  return;
#line 71
} while (0);
}
}

void
#line 75
bi_rate(eval_environ_t env)
#line 75

#line 75 "bi_other.m4"
{
#line 75
	
#line 75

#line 75
long __bi_argcnt;
#line 75
char * key;
#line 75
        long  interval;
#line 75
        long  mincnt;
#line 75
        
#line 75
get_string_arg(env, 1, &key);
#line 75
        get_numeric_arg(env, 2, &interval);
#line 75
        get_numeric_arg(env, 3, &mincnt);
#line 75
        
#line 75
get_numeric_arg(env, 0, &__bi_argcnt);
#line 75
        adjust_stack(env, __bi_argcnt + 1);
#line 75

#line 75
	if (prog_trace_option & BUILTIN_MASK_other)
#line 75
		prog_trace(env, "rate %s %lu %lu",key, interval, ((__bi_argcnt > 2) ? mincnt : 0));;
#line 75

{
	double rate;
	long lrate;
		
		if (!(get_rate(key, &rate, ((__bi_argcnt > 2) ? mincnt : 0)) == mf_success))
#line 80
			env_throw_bi(env, mfe_dbfailure, "rate", _("Cannot get rate for %s"),key)
#line 82
;
	lrate = rate * interval;
	
	
#line 85
do {
#line 85
  push(env, (STKVAL) (lrate));
#line 85
  return;
#line 85
} while (0);
}
}

void
#line 89
bi_debug_level(eval_environ_t env)
#line 89

#line 89 "bi_other.m4"
{
#line 89
	
#line 89

#line 89
long __bi_argcnt;
#line 89
char * modname;
#line 89
        
#line 89
get_string_arg(env, 1, &modname);
#line 89
        
#line 89
get_numeric_arg(env, 0, &__bi_argcnt);
#line 89
        adjust_stack(env, __bi_argcnt + 1);
#line 89

#line 89
	if (prog_trace_option & BUILTIN_MASK_other)
#line 89
		prog_trace(env, "debug_level %s",((__bi_argcnt > 0) ? modname : ""));;
#line 89

{
	int level;
		if (!(debug_module_level(((__bi_argcnt > 0) ? modname : NULL), &level) == 0))
#line 92
			env_throw_bi(env, mfe_range, "debug_level", _("Invalid module name: %s"),modname)
#line 94
;
	
#line 95
do {
#line 95
  push(env, (STKVAL) (level));
#line 95
  return;
#line 95
} while (0);
}
}

void
#line 99
bi_debug_spec(eval_environ_t env)
#line 99

#line 99 "bi_other.m4"
{
#line 99
	
#line 99

#line 99
long __bi_argcnt;
#line 99
char * modnames;
#line 99
        
#line 99
get_string_arg(env, 1, &modnames);
#line 99
        
#line 99
get_numeric_arg(env, 0, &__bi_argcnt);
#line 99
        adjust_stack(env, __bi_argcnt + 1);
#line 99

#line 99
	if (prog_trace_option & BUILTIN_MASK_other)
#line 99
		prog_trace(env, "debug_spec %s",((__bi_argcnt > 0) ? modnames : ""));;
#line 99

{
	char *buf;
	char *s;
	size_t off;

 	int rc = debug_spec_string(((__bi_argcnt > 0) ? modnames : NULL), &buf);
		if (!(rc == 0))
#line 106
			env_throw_bi(env, mfe_failure, "debug_spec", "%s",mu_strerror(rc))
#line 108
;
	s = (char*) env_data_ref(env, (off = heap_reserve(env, strlen(buf) + 1)));
	strcpy(s, buf);
	free(buf);
	
#line 112
do {
#line 112
  push(env, (STKVAL) (off));
#line 112
  return;
#line 112
} while (0);
}
}

void
#line 116
bi_debug(eval_environ_t env)
#line 116

#line 116 "bi_other.m4"
{
#line 116
	
#line 116

#line 116

#line 116
char * spec;
#line 116
        
#line 116
get_string_arg(env, 0, &spec);
#line 116
        
#line 116

#line 116
        adjust_stack(env, 1);
#line 116

#line 116
	if (prog_trace_option & BUILTIN_MASK_other)
#line 116
		prog_trace(env, "debug %s",spec);;
#line 116

{
	debug_parse_spec(spec);
}
}

void
#line 122
bi_program_trace(eval_environ_t env)
#line 122

#line 122 "bi_other.m4"
{
#line 122
	
#line 122

#line 122

#line 122
char * name;
#line 122
        
#line 122
get_string_arg(env, 0, &name);
#line 122
        
#line 122

#line 122
        adjust_stack(env, 1);
#line 122

#line 122
	if (prog_trace_option & BUILTIN_MASK_other)
#line 122
		prog_trace(env, "program_trace %s",name);;
#line 122

{
	enable_prog_trace(name);
}
}

void
#line 128
bi_cancel_program_trace(eval_environ_t env)
#line 128

#line 128 "bi_other.m4"
{
#line 128
	
#line 128

#line 128

#line 128
char * name;
#line 128
        
#line 128
get_string_arg(env, 0, &name);
#line 128
        
#line 128

#line 128
        adjust_stack(env, 1);
#line 128

#line 128
	if (prog_trace_option & BUILTIN_MASK_other)
#line 128
		prog_trace(env, "cancel_program_trace %s",name);;
#line 128

{
	disable_prog_trace(name);
}
}	

void
#line 134
bi_stack_trace(eval_environ_t env)
#line 134

#line 134 "bi_other.m4"
{
#line 134
	
#line 134

#line 134

#line 134

#line 134

#line 134

#line 134
        adjust_stack(env, 0);
#line 134

#line 134
	if (prog_trace_option & BUILTIN_MASK_other)
#line 134
		prog_trace(env, "stack_trace");;
#line 134

{
	runtime_stack_trace(env);
}
}


#line 140
void
#line 140
other_init_builtin()
#line 140
{
#line 140
	#line 57 "bi_other.m4"
va_builtin_install_ex("validuser", bi_validuser, 0, 0, dtype_number, 1, 0, 0, dtype_string);
#line 63 "bi_other.m4"
va_builtin_install_ex("interval", bi_interval, 0, 0, dtype_number, 1, 0, 0, dtype_string);
#line 75 "bi_other.m4"
va_builtin_install_ex("rate", bi_rate, 0, 0, dtype_number, 3, 1, 0, dtype_string, dtype_number, dtype_number);
#line 89 "bi_other.m4"
va_builtin_install_ex("debug_level", bi_debug_level, 0, 0, dtype_number, 1, 1, 0, dtype_string);
#line 99 "bi_other.m4"
va_builtin_install_ex("debug_spec", bi_debug_spec, 0, 0, dtype_string, 1, 1, 0, dtype_string);
#line 116 "bi_other.m4"
va_builtin_install_ex("debug", bi_debug, 0, 0, dtype_unspecified, 1, 0, 0, dtype_string);
#line 122 "bi_other.m4"
va_builtin_install_ex("program_trace", bi_program_trace, 0, 0, dtype_unspecified, 1, 0, 0, dtype_string);
#line 128 "bi_other.m4"
va_builtin_install_ex("cancel_program_trace", bi_cancel_program_trace, 0, 0, dtype_unspecified, 1, 0, 0, dtype_string);
#line 134 "bi_other.m4"
va_builtin_install_ex("stack_trace", bi_stack_trace, 0, 0, dtype_unspecified, 0, 0, 0, dtype_unspecified);

#line 140 "bi_other.m4"
		
#line 140
}
#line 589 "../mfd/snarf.m4"

#line 589

